# Spielereien mit Lambda

myTrue= lambda x,y: x
myFalse= lambda x,y: y
myAnd=lambda x,y:x(y,x)
myOr=lambda x,y:x(x,y)
myNot=lambda x:x(myFalse,myTrue)
myIf=lambda p,x,y:p(x,y)

def asString(a): # Rueckverwandlung in gewoehnlichen String
    if a==myTrue: return "TRUE"
    if a==myFalse: return "FALSE"
    
print("de-Morgans Gesetz nachgerechnet: not(a or b)= not(a) and not(b)")

for a in [myFalse,myTrue]:
    for b in [myFalse,myTrue]:
        L=myNot(myOr(a,b))
        R=myAnd(myNot(a),myNot(b))
        print("a=",asString(a)," b=",asString(b)," not(a or b)=",asString(L)," not(a) and not(b)=",asString(R))


print("--------------------------------------")
print()

print("Rechnen mit Lambda")

def P2L(n): # Verwandelt Python-Zahl in Lambda-Zahl
    if n==0: return myZero
    return mySucc(P2L(n-1))
def L2P(num): # Wandelt Lambda-Zahl -> Python 
    return num(lambda x: x+1)(0)
    
myZero=lambda f: lambda x: x
mySucc=lambda num: lambda f: lambda x: f(num(f)(x))
myAdd=lambda a,b: a(mySucc)(b) 
myMul=lambda a,b: lambda f: a(b(f))
myPot=lambda a,b: b(a)

eins=mySucc(myZero)
zwei=mySucc(eins)
drei=mySucc(zwei)
vier=mySucc(drei)


print("3=",L2P(drei))
print("2+3=",L2P(myAdd(zwei,drei)))
print("2*3=",L2P(myMul(zwei,drei)))
print("2^3=",L2P(myPot(zwei,drei)))
      
