# Kapitel 12a - Bildverarbeitung Teil 1

from SWGui import *
from math import *

initSWGui()

buLinie=SWButton(text="Linie")
buLinie.setCommand(lambda: zeichneLinie1(10,20,300,200))
buKreis=SWButton(text="Kreis")
buKreis.setCommand(lambda: zeichneKreis(200,200,100))
buSinus=SWButton(text="Sinus")
buSinus.setCommand(lambda: zeichneSinus())

n=400
Zeichenfeld=SWCanvas(width=n,height=n)
bitmap=Zeichenfeld.createImage(0,0,(n,n))


def zeichneLinie1(x1,y1,x2,y2):
    m=(y2-y1)/float(x2-x1) # Steigung
    b=y1-m*x1 # Achsenabschnitt y-m*x=b
    for x in range(x1,x2):
        y=int(m*x+b)
        bitmap.setPixel(x,y,0) # Setze auf schwarz

def zeichneKreis(x,y,r):
    for winkel in range(360):
        xk=int(x+r*cos(winkel*pi/180))
        yk=int(y+r*sin(winkel*pi/180))
        bitmap.setPixel(xk,yk,0)

def zeichneSinus():
    for xs in range(n):
        x=xs*2*pi/n
        y=n/2-n/3*sin(x)
        bitmap.setPixel(xs,int(y),0)
        
