# Kapitel 12b - Bildverarbeitung Teil 2

from SWGui import *

initSWGui()

n=200
Zeichenfeld=SWCanvas(width=n,height=n)

bitmap=Zeichenfeld.createImage(0,0,(n,n))


print("Bildabmessungen: ", bitmap.getDim())

# Jetzt das Apfelmaennchen zeichnen        
for ix in range(n):
    for iy in range(n):
        x=(ix-n/2)/(n/3)
        y=(iy-n/2)/(n/3)
        c=complex(x,y)
        z=0
        counter=85
        while counter>0:
            counter+=-1
            z=z*z+c
            if abs(z)>2:
                bitmap.setPixelRGB(ix,iy,[255-3*counter,255-2*counter,255-counter],False)
                break
            bitmap.setPixelRGB(ix,iy,[0,0,0],False)
    bitmap.flush() # berechnete Punkte darstellen

# Diese Variante zeichnet die Pixel nicht sofort (Parameter
# False in setPixelRGB), sondern erst für jede komplette Spalte,
# dadurch ist sie etwas schneller

