# Kapitel 12d - Bildverarbeitung Teil 4 : DLA
# Diffussion limited aggregation

from SWGui import *
from random import random
from math import *

initSWGui()
n=150
Zeichenfeld=SWCanvas(width=n,height=n)
bitmap=Zeichenfeld.createImage(0,0,(n,n))
for ix in range(n):
    for iy in range(n):
        bitmap.setPixel(ix,iy,255,False)
bitmap.flush()        


r=3 # Radius, ab dem die Teilchen laufen
xm=n/2 # Mitelpunkt 
ym=n/2
bitmap.setPixelRGB(xm,ym,[0,0,255])

N=1000 # Anzahl der Teilchen
na=0
for i in range(N):
    print("Teilchen ",i," bereits angelagert: ", na)
    alpha=2*pi*random()
    x=xm+r*cos(alpha)
    y=ym+r*sin(alpha)
    while True:
        if x<0 or y<0 or x>n or y>n: break # ausserhalb
        if (bitmap.getPixelRGB(x,y+1)==[0,0,255] or
            bitmap.getPixelRGB(x,y-1)==[0,0,255] or
            bitmap.getPixelRGB(x+1,y)==[0,0,255] or
            bitmap.getPixelRGB(x-1,y)==[0,0,255]):
            bitmap.setPixelRGB(x,y,[0,0,255])
            na+=1
            if sqrt((x-xm)*(x-xm)+(y-ym)*(y-ym))>=r-1: r+=1
            break
        if random()>0.5: x+=1
        else: x+=-1
        if random()>0.5: y+=1
        else: y+=-1




